@echo off
rem
rem            UPLOAD.BAT - Load the most recent .hex (S-record) file generated with the 68000 IDE
rem                    into the target board (68k-MBC)
rem
rem            USAGE:      UPLOAD
rem
rem            My suggestion is to make a link to UPLOAD.BAT and place it into an handy place 
rem            (i.e. on the desktop) so you have just double click on it to make the upload.
rem
rem            ----------------------------------------------------------------------------
rem
rem            NOTE 1: 68000 IDE and Tera Term must be already installed in your system.
rem
rem            NOTE 2: The macro file Load68kIDE.ttl must be adapted to your system ad copied
rem                    into the Tera Term installation directory (normally C:\Program Files (x86)\teraterm).
rem
rem            NOTE 3: the UPLOAD.BAT and the required srec_cat.exe files must be both placed in the 
rem                    directory containing the user source files used with the 68000 IDE
rem                    (normally C:\Ide68k\Examples).
rem                    The srec_cat.exe utility can be downloaded from here:
rem                    http://sourceforge.net/projects/srecord/files/srecord-win32/1.64/srecord-1.64-win32.zip
rem
rem            ----------------------------------------------------------------------------
rem                                                           by J4F
rem


FOR /F "eol=| delims=" %%I IN ('DIR "*.hex" /A-D /B /O-D /TW 2^>nul') DO (
    SET NewestFile=%%I
    GOTO FoundFile
)
ECHO No *.hex file found!
GOTO :end

:FoundFile
ECHO Newest *.hex file found is: %NewestFile%

copy /y %NewestFile% tmp.s > nul

srec_cat tmp.s -Motorola -o load.s -Motorola -address-length=3 -CRLF

echo * * * Remember to close the Tera Term windows before a new upload! * * *

rem *****************************************************************************************
rem *                                                                                       *
rem * Adapt the following command line according to your installation!                      *
rem *                                                                                       *
rem * c=5 means using COM5: as serial port;                                                 *
rem * "C:\Program Files (x86)\teraterm\ttermpro.exe" must be the complete path to           *
rem *  Tera Term (ttermpro.exe).                                                            *
rem *                                                                                       *
rem * NOTE: the script Load68kIDE.ttl must be placed in the same directory of ttermpro.exe  *
rem *                                                                                       *
"C:\Program Files (x86)\teraterm\ttermpro.exe" /c=5 /BAUD=115200 /w="68k-MBC Terminal" /m=Load68kIDE.ttl
rem *                                                                                       *
rem *****************************************************************************************
rem

echo All done. Bye bye...
goto :end

:end
