#!/bin/bash
#
# This script create a first temporary docker image for the GCC cross-compiler
# for the 68k-MBC board.
#
cd dockerBuild
docker build -t 68k-mbc_tmp .

#
# Create a temporary container (tmp) to complete the installation
# with the interactive shell
#
docker create -it --name tmp -v ~/docker:/opt/work 68k-mbc_tmp bash
echo " "
echo "***********************************************************************"
echo "Now from inside the shell of the running container execute the command:"
echo " "
echo "                             ./newlib.sh"
echo " "
echo "When completed terminate the container (with the 'exit' command) and"
echo "execute the last script:"
echo " "
echo "                             ./build2.sh"
echo "***********************************************************************"
echo " "
docker start  -i -a tmp

#
# Now from inside the shell of the running container execute the command:
#
#                             ./newlib.sh
#
# When completed terminate the container (with the "exit" command) and 
# execute: ./build2.sh
