
//
// m68k-elf-gcc "bare-metal" compiler test for the 68k-MBC board (No library is required)
//

void userLed(const char c);

int main(void)
{
    asm("move.l #0x1000,%sp");      // Set up initial stack pointer

    char i;
    i = 0x01;
    userLed(i);                     // Turn user led on

    asm("stop #0x2700");            // Halt the CPU here after the execution.
}


// Turn User led on/off using the IOS Opcodes
void userLed(volatile char c) 
{
    asm("movem.l %d0/%d1/%a0,-(%sp)\n\t"    // Save some registers
        "move.b #00,(0xFFFFD).l\n\t"        // move.b  #USERLED_OPC,(STOPC_PORT).l  ; Write USER LED opcode to IOS
        "move.b %d0,(0xFFFFC).l\n\t"        // move.b  d0,(EXCWR_PORT ).l           ; Send current char value
        "movem.l (%sp)+,%d0/%d1/%a0");      // Restore some registers
}

