
//
// m68k-elf-gcc "bare-metal" compiler test for the 68k-MBC board
//

void outch(const char c);
void printString(const char *s);
void printNumber(unsigned int n);

int main(void)
{
    asm("move.l #0x10000,%sp"); // Set up initial stack pointer

    printString("\r\n* m68k-elf-gcc \"bare-metal\" compiler test *\r\n\n");
    int i;
    for (i=0;i<10;i++)
    {
        printNumber(i);
        printString("\r\n");
        //printf("i = %u\r\n\",i); // No printf available here, he he...
    }
    printString("\r\n* End of test *\r\n");
    asm("stop #0x2700");           // Halt the CPU here after the execution.
}

// Print a character using the IOS Opcodes
void outch(volatile char c) {
    asm("movem.l %d0/%d1/%a0,-(%sp)\n\t"  // Save modified registers
        "move.b #01,(0xFFFFD).l\n\t"        // move.b  #SER1TX_OPC,(STOPC_PORT).l  ; Write SERIAL 1 TX opcode to IOS
        "move.b %d0,(0xFFFFC).l\n\t"       // move.b  d0,(EXCWR_PORT ).l          ; Print current char
        "movem.l (%sp)+,%d0/%d1/%a0");    // Restore registers
}

// Print a string.
void printString(const char *s) {
    while (*s != 0) {
        outch(*s);
        s++;
    }
}

// Quick and dirty routine to print decimal number up to 10 digits
// long. Suppresses leading zeros.
void printNumber(unsigned int n) {
    unsigned int d;
    short digitPrinted = 0;
    unsigned int mult = 1000000000;

    while (mult > 1) {
        d = n / mult;
        if (d == 0) {
            if (digitPrinted) {
                outch(d + '0');
            }
        } else {
            outch(d + '0');
            digitPrinted = 1;
        }
        n = n - d * mult;
        mult = mult / 10;
    }
    outch(n + '0');
}
