@echo off
rem
rem            AL.BAT - Assemble with Easy68k and load the S-record 68000 executable
rem
rem            USAGE:      AL <source.x68>
rem
rem            ----------------------------------------------------------------------------
rem
rem            NOTE 1: Easy68K and Tera Term must be already installed in your system.
rem
rem            NOTE 2: The macro file Load68k.ttl must be adapted to your system ad copied
rem                    into the Tera Term installation directory.
rem
rem            ----------------------------------------------------------------------------
rem                                                           by J4F
rem
if .%1==. goto :error2
set srcfile=%1
if not exist %srcfile% goto :error1

for %%i in (%srcfile%) do set srfile=%%~ni.s68

C:\EASy68K\EDIT68K.exe %srcfile% /c

copy /y %srfile% load.s > nul
echo * * * Remember to close the Tera Term windows before a new upload! * * *

rem *****************************************************************************************
rem *                                                                                       *
rem * Adapt the following command line according to your installation!                      *
rem *                                                                                       *
rem * c=5 means using COM5: as serial port;                                                 *
rem * "C:\Program Files (x86)\teraterm\ttermpro.exe" must be the complete path to           *
rem *  Tera Term (ttermpro.exe).                                                            *
rem *                                                                                       *
rem * NOTE: the script Load68k.ttl must be placed in the same directory of ttermpro.exe     *
rem *                                                                                       *
"C:\Program Files (x86)\teraterm\ttermpro.exe" /c=5 /BAUD=115200 /w="68k-MBC Terminal" /m=Load68k.ttl
rem *                                                                                       *
rem *****************************************************************************************
rem

echo All done. Bye bye...
goto :end

:error2
echo Please specify a source file!
echo USAGE:      %0 ^<source_file.X68^>
goto :end

:error1
echo Error: file %srcfile% not found!

:end
